void IRAM_ATTR onTimerL_rec() {
  static uint32_t ZZ;
  uint32_t ZS;
  if ((!ParitetL) && STEP_L_level)
  {
    if (speed_stepL > toSpeed_div_spL) //Если мы в начале движения
    {
      ZZ += (speed_stepL - max_div_spX);
      ZS = ZZ >> SDVIG;
      if (ZS) {
        speed_stepL -= ZS;
        ZZ &= maska;//ZZ = 0;
        timerAlarmWrite(timerL, speed_stepL, true);
      }
    }
    else if (speed_stepL < toSpeed_div_spL) //Если мы завершаем движение
    {
      ZZ += (speed_stepL - max_div_spX); 
      ZS = ZZ >> SDVIG;
      if (ZS) {
        speed_stepL += ZS;
        ZZ &= maska;//ZZ = 0;
        timerAlarmWrite(timerL, speed_stepL, true);
      }
    }
    else
      ParitetL = true;
  }
  STEP_L_level = !STEP_L_level;
  digitalWrite(STEP_L, STEP_L_level);
  if (STEP_L_level) counter_stepL++; // Если начался шаг, увеличим счетчик шагов
}
//============================================================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//============================================================================================================

void IRAM_ATTR onTimerL() {
  static uint32_t ZZ;
  uint32_t ZS;
  if (STEP_L_level)
  {
    if (Start_F_L)
    {
      if (Steps_to_speed_L < counter_stepL) //Если мы в начале движения
      {
        ZZ += (speed_stepL - max_div_spX);
        ZS = ZZ >> SDVIG;
        if (ZS) {
          speed_stepL -= ZS;
          ZZ &= maska;//ZZ = 0;
          timerAlarmWrite(timerL, speed_stepL, true);
        }
      }
      else
      {
        Start_F_L = false;
      }
    }
    else if (Stop_F_L) //Если мы завершаем движение
    {
      if (speed_stepL < min_div_sp)
      {
        ZZ += (speed_stepL - max_div_spX); 
        ZS = ZZ >> SDVIG;
        if (ZS) {
          speed_stepL += ZS;
          ZZ &= maska;//ZZ = 0;
          timerAlarmWrite(timerL, speed_stepL, true);
        }
      }
    }
    else
    {
      if (counter_stepL < Steps_to_stop_L) Stop_F_L = true;  //Если мы на линии торможения...
    }
  }

  if (counter_stepL == 0) {
    Stop_F_L = Start_F_L = false;
    timerAlarmDisable(timerL);
    timer_volumeL  = false;
    return;
  }
  STEP_L_level = !STEP_L_level;
  digitalWrite(STEP_L, STEP_L_level);
  if (STEP_L_level) counter_stepL--;
}
//============================================================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//============================================================================================================

void IRAM_ATTR onTimerR_rec() {
  static uint32_t ZZ;
  uint32_t ZS;
  if (!ParitetR && STEP_R_level)
  {
    if (speed_stepR > toSpeed_div_spR) //Если мы в начале движения
    {
      ZZ += (speed_stepR - max_div_spX);
      ZS = ZZ >> SDVIG;
      if (ZS) {
        speed_stepR -= ZS;
        ZZ &= maska;//ZZ = 0;
        timerAlarmWrite(timerR, speed_stepR, true);
      }
    }
    else if (speed_stepR < toSpeed_div_spR) //Если мы завершаем движение
    {
      ZZ += (speed_stepR - max_div_spX);
      ZS = ZZ >> SDVIG;
      if (ZS) {
        speed_stepR += ZS;
        ZZ &= maska;//ZZ = 0;
        timerAlarmWrite(timerR, speed_stepR, true);
      }
    }
    else
      ParitetR = true;
  }

  STEP_R_level = !STEP_R_level;
  digitalWrite(STEP_R, STEP_R_level);
  if (STEP_R_level) counter_stepR++; // Если начался шаг, увеличим счетчик шагов
}
//============================================================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//============================================================================================================

void IRAM_ATTR onTimerR() {
  static uint32_t ZZ;
  uint32_t ZS;
  if (STEP_R_level)
  {
    if (Start_F_R)
    {
      if (Steps_to_speed_R < counter_stepR) //Если мы в начале движения
      {
        ZZ += (speed_stepR - max_div_spX);
        ZS = ZZ >> SDVIG;
        if (ZS) {
          speed_stepR -= ZS;
          ZZ &= maska;//ZZ = 0;
          timerAlarmWrite(timerR, speed_stepR, true);
        }
      }
      else
      {
        Start_F_R = false;
      }
    }
    else if (Stop_F_R) //Если мы завершаем движение
    {
      if (speed_stepR < min_div_sp)
      {

        ZZ += (speed_stepR - max_div_spX); 
        ZS = ZZ >> SDVIG;
        if (ZS) {
          speed_stepR += ZS;
          ZZ &= maska;//ZZ = 0;
          timerAlarmWrite(timerR, speed_stepR, true);
        }
      }
    } else
    {
      if (counter_stepR < Steps_to_stop_R) Stop_F_R = true;  //Если мы на линии торможения...
    }
  }

  if (counter_stepR == 0) {
    timerAlarmDisable(timerR);
    timer_volumeR  = false;
    return;
  }
  STEP_R_level = !STEP_R_level;
  digitalWrite(STEP_R, STEP_R_level);
  if (STEP_R_level) counter_stepR--;
}
//============================================================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//============================================================================================================
