#define SDVIG 9 //Коэффициент сдвига при равноускоренном движении - торможении
#define DIV_ 128 //Коэффициент (делитель) при равноускоренном движении - торможении
uint32_t maska; // маска для коэффициента сдвига

#define STEP_L 15 //Пин левого шага 
#define STEP_R 4 //Пин правого шага
#define STEPER_EN 2 //Пин врключения моторов// Функция инициализации уравления моторами.//////////////////////////////

#define DIR_L 13 //Пин направления левого шага 
#define DIR_R 16 //Пин направления правого шага


const uint32_t max_f_div_sp = 80; // На шаг
const uint32_t max_t_div_sp = 500; // На шаг
const uint32_t max_div_spX = 50; // На шаг

const uint32_t min_div_sp = 750; // На шаг
uint32_t max_div_sp = max_t_div_sp; // На шаг


// Объявляем переменные для хранения состояния двух моторов.
volatile bool STEP_L_level = false;
volatile bool STEP_R_level = false;
//=========================================
volatile uint32_t speed_stepL;
volatile uint32_t speed_stepR;

volatile uint32_t toSpeed_div_spL;
volatile uint32_t toSpeed_div_spR;
//=========================================
volatile bool Stop_F_L; //Флаг начала остановки
volatile bool Stop_F_R; //Флаг начала остановки
volatile bool Start_F_L; //Флаг начала движения
volatile bool Start_F_R; //Флаг начала движения
//=========================================
volatile uint32_t counter_stepL; //Счетчик шагов левого мотора
volatile uint32_t counter_stepR; //Счетчик шагов правого мотора
//=========================================
uint8_t sost = 0; // Состояние текущего движения, требуется для качественной записи
// sost = 1 - foraward
// sost = 2 - backward
// sost = 3 - left
// sost = 31 - forawardleft
// sost = 32 - backwardleft
// sost = 4 - right
// sost = 41 - forawardright
// sost = 42 - backwardright
// sost = 0 - stop
//=========================================
uint8_t sost_for_Rec = 0; // Состояние текущего движения, требуется для качественной записи
// sost = 1 - foraward
// sost = 2 - backward
// sost = 3 - left
// sost = 4 - right
// sost = 0 - stop

#define FORVARD_cod 1
#define BACKWARD_cod 2
#define LEFT_cod 3
#define FLEFT_cod 31
#define BLEFT_cod 32
#define RIGHT_cod 4
#define FRIGHT_cod 41
#define BRIGHT_cod 42
#define STOP_cod 0

bool timer_volumeL;
bool timer_volumeR;
//=========================================

bool DIR_L_level = false;
bool DIR_R_level = false;


volatile bool ParitetL = false;
volatile bool ParitetR = false;


//max_div_sp = max_t_div_sp;
//max_div_sp = max_f_div_sp;

uint32_t Steps_For_maxspeedf; //Количество шагов для разгона
uint32_t Steps_For_maxspeedt; //Количество шагов для разгона
uint32_t Steps_For_maxspeed; //Количество шагов для разгона

uint32_t Steps_to_speed_L, Steps_to_stop_L;  //Количество шагов для разгона\торможения для текущего участка
uint32_t Steps_to_speed_R, Steps_to_stop_R;  //Количество шагов для разгона\торможения для текущего участка

bool STEPER_EN_level = true;


int timer_stop; // для отключения двигателей при простое
//===============================
void setup_motor_system()
{
  STEP_L_level = false;
  STEP_R_level = false;
  DIR_L_level = false;
  DIR_R_level = false;
  STEPER_EN_level = true;

  pinMode(STEP_L, OUTPUT);
  pinMode(STEP_R, OUTPUT);
  pinMode(DIR_L, OUTPUT);
  pinMode(DIR_R, OUTPUT);
  pinMode(STEPER_EN, OUTPUT);

  digitalWrite(STEP_L, STEP_L_level);
  digitalWrite(STEP_R, STEP_R_level);
  digitalWrite(DIR_L, DIR_L_level);
  digitalWrite(DIR_R, DIR_R_level);
  digitalWrite(STEPER_EN, STEPER_EN_level);
  toSpeed_div_spL = speed_stepL = min_div_sp; //Начальная скорость минимальна
  toSpeed_div_spR = speed_stepR = min_div_sp; //Начальная скорость минимальна
  timer_volumeL = true;
  timer_volumeR = true;
  timer_stop = 0;
  sost_for_Rec = 0;
  //Расчет маски для делителя
  maska = 0;
  for(int i=0;i<SDVIG;i++)  maska += 1<<i; 
  
}

//=== установка движения по данным =============================
void Set_trajectory() //Подготовка считанноей команды к исполнению
{
  DIR_L_level = command_in_works.L_motorDIR;
  DIR_R_level = command_in_works.R_motorDIR;
  counter_stepL = command_in_works.L_n_steps; // Количество шагов для левого мотора
  counter_stepR = command_in_works.R_n_steps; // Количество шагов для правого мотора
  digitalWrite(DIR_L, DIR_L_level);
  digitalWrite(DIR_R, DIR_R_level);
  
}
//===============================
//===============================
void Record_trajectory(uint8_t sostNew) //Запись траектории
{
  if (sost != sostNew) //Если новое состояние изменилось - т.е. робот двигается в др.сторону.
  {
    if (num_commands == 0)
    {
      erease_com();
    }
    if (timer_volumeL)
    {
      timerAlarmDisable(timerL);
      timer_volumeL  = false;
    }
    if (timer_volumeR)
    {
      timerAlarmDisable(timerR);
      timer_volumeR  = false;
    }
    num_commands++;
    command_in_works.L_motorDIR = DIR_L_level;
    command_in_works.R_motorDIR = DIR_R_level;
    command_in_works.L_n_steps = counter_stepL; // Количество шагов для левого мотора
    command_in_works.R_n_steps = counter_stepR; // Количество шагов для правого мотора
    write_to_pref(num_commands);
    sost = sostNew;
    counter_stepL = 0; //Обнуляем счетчики шагов
    counter_stepR = 0; //Обнуляем счетчики шагов
  }
}
// == Включение /отключние моторов
void motor_off()
{
  // Отключаем все колеса.
  if (!STEPER_EN_level)
  {
    STEPER_EN_level = true;
    digitalWrite(STEPER_EN, STEPER_EN_level);
  }
}
//===============================
void motor_on()
{
  // Включаем все колеса.
  if (STEPER_EN_level)
  {
    STEPER_EN_level = false;
    digitalWrite(STEPER_EN, STEPER_EN_level);
  }
}
//===============================


// движение вперед./////////////////////////////////////////////////////////
void forward()
{
  //1. Если предыдущий не форвард снижаем скорость до минималки
  if ((sost_for_Rec != FORVARD_cod) && ((speed_stepL < min_div_sp) || (speed_stepR < min_div_sp))) //Если состояние не Форвард и не завершено торможение до безопасной скорости
  {
    toSpeed_div_spL = toSpeed_div_spR = min_div_sp;  ParitetL = ParitetR = false; // Предлагаем роботу торможение снижением частоты шагов.
    return;
  }

  if (sost_for_Rec != FORVARD_cod) {
    max_div_sp = max_f_div_sp; //Увеличиваем максимальную скорость для прямолинейного движения
    timerAlarmDisable(timerL); timer_volumeL = false;
    timerAlarmDisable(timerR); timer_volumeR = false;

    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
    sost_for_Rec = FORVARD_cod;

    motor_on();
    Record_trajectory(FORVARD_cod);
    timer_stop = 0;

    // Если двигатель будет работать не в ту сторону,
    // поменять на нем контакты местами.
    DIR_L_level = true;
    DIR_R_level = false;
    digitalWrite(DIR_L, DIR_L_level);
    digitalWrite(DIR_R, DIR_R_level);
    if (!timer_volumeL) {
      timerAlarmEnable(timerL);
      timer_volumeL = true;
    }
    if (!timer_volumeR) {
      timerAlarmEnable(timerR);
      timer_volumeR = true;
    }
  }
  else // Если пытались изменить поведение но передумали...
  {
    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
  }
}
//===============================
// Поворот налево с блокировкой левых колес.//////////////////////////////
void forward_left()
{
  //1. Если предыдущий не форвард снижаем скорость до минималки
  if ((sost_for_Rec != FLEFT_cod) && ((speed_stepL < min_div_sp) || (speed_stepR < min_div_sp))) //Если состояние не Форвард и не завершено торможение до безопасной скорости
  {
    toSpeed_div_spL = toSpeed_div_spR = min_div_sp;  ParitetL = ParitetR = false; // Предлагаем роботу торможение снижением частоты шагов.
    return;
  }

  if (sost_for_Rec != FLEFT_cod) {
    max_div_sp = max_t_div_sp; //Уменьшаем максмальную скорость для поворотов
    timerAlarmDisable(timerL); timer_volumeL = false;
    timerAlarmDisable(timerR); timer_volumeR = false;

    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
    sost_for_Rec = FLEFT_cod;
    motor_on();
    Record_trajectory(FLEFT_cod);
    timer_stop = 0;
    DIR_L_level = true;
    DIR_R_level = true;
    digitalWrite(DIR_L, DIR_L_level);
    digitalWrite(DIR_R, DIR_R_level);
    if (!timer_volumeR) {
      timerAlarmEnable(timerR);
      timer_volumeR  = true;
    }
    if (timer_volumeL) {
      timerAlarmDisable(timerL);
      timer_volumeL  = false;
    }
  }
  else // Если пытались изменить поведение но передумали...
  {
    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
  }
// блокируем вращение левых колес.
// правые колеса вращаются.
}
//===============================
// Поворот налево.////////////////////////////////////////////////////////
void left()
{
  //1. Если предыдущий не LEFT снижаем скорость до минималки
  if ((sost_for_Rec != LEFT_cod) && ((speed_stepL < min_div_sp) || (speed_stepR < min_div_sp))) //Если состояние не Форвард и не завершено торможение до безопасной скорости
  {
    toSpeed_div_spL = toSpeed_div_spR = min_div_sp;  ParitetL = ParitetR = false; // Предлагаем роботу торможение снижением частоты шагов.
    return;
  }

  if (sost_for_Rec != LEFT_cod) {
    max_div_sp = max_t_div_sp; //Уменьшаем максмальную скорость для поворотов
    timerAlarmDisable(timerL); timer_volumeL = false;
    timerAlarmDisable(timerR); timer_volumeR = false;

    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
    sost_for_Rec = LEFT_cod;

    //  save_tec_sost(); //Сохраняяем текущее состояние моторов
    motor_on();
    Record_trajectory(LEFT_cod);
    timer_stop = 0;
    // Если двигатель будет работать не в ту сторону,
    // поменять на нем контакты местами.
    DIR_L_level = true;
    DIR_R_level = true;
    digitalWrite(DIR_L, DIR_L_level);
    digitalWrite(DIR_R, DIR_R_level);
    if (!timer_volumeL) {
      timerAlarmEnable(timerL);
      timer_volumeL = true;
    }
    if (!timer_volumeR) {
      timerAlarmEnable(timerR);
      timer_volumeR = true;
    }
  }
  else // Если пытались изменить поведение но передумали...
  {
    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
  }
  // левые колеса вращаются назад
  // правые колеса вращаются.
}
//===============================
// Поворот направо с блокировкой правых колес.///////////////////////////
void forward_right()
{
  //1. Если предыдущий не форвард снижаем скорость до минималки
  if ((sost_for_Rec != FRIGHT_cod) && ((speed_stepL < min_div_sp) || (speed_stepR < min_div_sp))) //Если состояние не Форвард и не завершено торможение до безопасной скорости
  {
    toSpeed_div_spL = toSpeed_div_spR = min_div_sp;  ParitetL = ParitetR = false; // Предлагаем роботу торможение снижением частоты шагов.
    return;
  }
  if (sost_for_Rec != FRIGHT_cod) {
    max_div_sp = max_t_div_sp; //Уменьшаем максмальную скорость для поворотов
    timerAlarmDisable(timerL); timer_volumeL = false;
    timerAlarmDisable(timerR); timer_volumeR = false;

    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
    sost_for_Rec = FRIGHT_cod;

    motor_on();
    toSpeed_div_spL = max_div_sp;
    toSpeed_div_spR = max_div_sp;

    Record_trajectory(FRIGHT_cod);
    timer_stop = 0;
    DIR_L_level = false;
    DIR_R_level = false;
    digitalWrite(DIR_L, DIR_L_level);
    digitalWrite(DIR_R, DIR_R_level);
    if (!timer_volumeL) {
      timerAlarmEnable(timerL);
      timer_volumeL = true;
    }
    if (timer_volumeR) {
      timerAlarmDisable(timerR);
      timer_volumeR  = false;
    }
  }
  else // Если пытались изменить поведение но передумали...
  {
    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
  }
  // блокируем вращение левых колес.
  // правые колеса вращаются.
}
//===============================
///////////////////////////////////////////////////////////////////////
void right()
{
  //1. Если предыдущий не RIGHT снижаем скорость до минималки
  if ((sost_for_Rec != RIGHT_cod) && ((speed_stepL < min_div_sp) || (speed_stepR < min_div_sp))) //Если состояние не Форвард и не завершено торможение до безопасной скорости
  {
    toSpeed_div_spL = toSpeed_div_spR = min_div_sp;  ParitetL = ParitetR = false; // Предлагаем роботу торможение снижением частоты шагов.
    return;
  }

  if (sost_for_Rec != RIGHT_cod) {
    max_div_sp = max_t_div_sp; //Уменьшаем максмальную скорость для поворотов
    timerAlarmDisable(timerL); timer_volumeL = false;
    timerAlarmDisable(timerR); timer_volumeR = false;

    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
    sost_for_Rec = RIGHT_cod;

    //  save_tec_sost(); //Сохраняяем текущее состояние моторов
    motor_on();
    Record_trajectory(RIGHT_cod);
    timer_stop = 0;

    // Если двигатель будет работать не в ту сторону,
    // поменять на нем контакты местами.
    DIR_L_level = false;
    DIR_R_level = false;
    digitalWrite(DIR_L, DIR_L_level);
    digitalWrite(DIR_R, DIR_R_level);
    if (!timer_volumeL) {
      timerAlarmEnable(timerL);
      timer_volumeL = true;
    }
    if (!timer_volumeR) {
      timerAlarmEnable(timerR);
      timer_volumeR = true;
    }
  }
  else // Если пытались изменить поведение но передумали...
  {
    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
  }

  // левые колеса вращаются назад
  // правые колеса вращаются.
}
//===============================
// Включаем движение назад.////////////////////////////////////////////
void backward()
{
  //1. Если предыдущий не BACKWARD снижаем скорость до минималки
  if ((sost_for_Rec != BACKWARD_cod) && ((speed_stepL < min_div_sp) || (speed_stepR < min_div_sp))) //Если состояние не Форвард и не завершено торможение до безопасной скорости
  {
    toSpeed_div_spL = toSpeed_div_spR = min_div_sp;  ParitetL = ParitetR = false; // Предлагаем роботу торможение снижением частоты шагов.
    return;
  }

  if (sost_for_Rec != BACKWARD_cod) {
    max_div_sp = max_f_div_sp; //Увеличиваем максимальную скорость для прямолинейного движения
    timerAlarmDisable(timerL); timer_volumeL = false;
    timerAlarmDisable(timerR); timer_volumeR = false;

    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
    sost_for_Rec = BACKWARD_cod;

    motor_on();
    Record_trajectory(BACKWARD_cod);
    timer_stop = 0;

    // Меняем направление вращения двигателей.
    // Если двигатель будет работать не в ту сторону,
    // поменять на нем контакты местами.
    DIR_L_level = false;
    DIR_R_level = true;
    digitalWrite(DIR_L, DIR_L_level);
    digitalWrite(DIR_R, DIR_R_level);
    if (!timer_volumeL) {
      timerAlarmEnable(timerL);
      timer_volumeL = true;
    }
    if (!timer_volumeR) {
      timerAlarmEnable(timerR);
      timer_volumeR = true;
    }
  }
  else // Если пытались изменить поведение но передумали...
  {
    if (toSpeed_div_spL != max_div_sp)   {
      toSpeed_div_spL = max_div_sp;
      ParitetL = false;
    }
    if (toSpeed_div_spR != max_div_sp)  {
      toSpeed_div_spR = max_div_sp;
      ParitetR = false;
    }
  }
}
//===============================
//////////////////////////////////////////////////////////////////
void backward_left()
{
  timer_stop = 0;
  toSpeed_div_spL = max_div_sp;
  toSpeed_div_spR = max_div_sp;

  // Меняем направление вращения двигателей.
}
//===============================
///////////////////////////////////////////////////////////////
void backward_right()
{
  timer_stop = 0;
  toSpeed_div_spL = max_div_sp;
  toSpeed_div_spR = max_div_sp;

  // Меняем направление вращения двигателей.
}
// Остановка////////////////////////////////////////////////////
void _stop()
{
  //1. Если предыдущий не BACKWARD снижаем скорость до минималки
  if ((sost_for_Rec != STOP_cod) && ((speed_stepL < min_div_sp) || (speed_stepR < min_div_sp))) //Если состояние не Форвард и не завершено торможение до безопасной скорости
  {
    toSpeed_div_spL = toSpeed_div_spR = min_div_sp;  ParitetL = ParitetR = false; // Предлагаем роботу торможение снижением частоты шагов.
    return;
  }
  if (sost_for_Rec != STOP_cod) {
    timerAlarmDisable(timerL); timer_volumeL = false;
    timerAlarmDisable(timerR); timer_volumeR = false;

    sost_for_Rec = STOP_cod;
  }
  else
  {
    //if (timer_stop <= 10) motor_on();
    // Блокируем все колеса.
    if (timer_stop > 10) motor_off();
    else if ((!timer_volumeL) && (!timer_volumeR)) timer_stop++; //Если оба мотора стоят то ждем 10 тиков и отключает моторы
  }
}


